/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. See
 * http://www.eu-egee.org/partners/ for details on the copyright holders.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package org.glite.security.delegation;

import org.apache.log4j.Logger;

import org.glite.security.delegation.GrDPX509Util;
import org.glite.security.delegation.impl.GliteDelegation;

import java.net.URL;

import java.util.Random;


/*
 * Sample local client side for test purposes
 */
public class Client {
    public static void main(String[] args) throws Exception {
        Logger logger = Logger.getLogger(Client.class);
        String location = args[1];
        String delegationID = args[0];

        boolean TEST_PUT_METHOD = true;

        Random generator = new Random();
        int rnd = generator.nextInt(65000);
        delegationID = Integer.toString(rnd);

        logger.debug(location + delegationID);

        URL endPoint = new URL(args[1]);

        String pkc10ReqCert = null;

        //Here is a sample code for standalone test 
        
        GliteDelegation gliteDelegation = new GliteDelegation();
        pkc10ReqCert = gliteDelegation.getProxyReq(delegationID);

        if (pkc10ReqCert != null) {
            logger.debug("Certificate Request \n" + pkc10ReqCert);
        } else {
            System.out.println("Error, Service refused to perform delegation");
            System.exit(0);
        }

        if (TEST_PUT_METHOD) {
            DelegationHandler dlgHandler = new DelegationHandler(pkc10ReqCert,
                    delegationID, GrDPX509Util.getDlgorPropertyFile());
            //Here is a sample code for Server-based and standalone test
            gliteDelegation.putProxy(delegationID,dlgHandler.getPEMProxyCertificate());
        } else {
            System.out.println("Error, Service refused to perform delegation");
        }
    }
}
