/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. See
 * http://www.eu-egee.org/partners/ for details on the copyright holders.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package org.glite.security.delegation;

import org.glite.security.delegation.GrDPX509Util;


/*
 * Finds an issued proxy certificate in certificate cache
 * base on three parameters.
 * Delegation ID
 * User DN
 * Path location
 */
public class FindProxyInCache {
    private static String cacheLocation = null;
    private static String delegationID = null;
    private static String userDN = null;

    public static void main(String[] args) {
        String howToUse = "Where [options] are:\n" + " -dID <Delegation ID>\n" +
            "\tDelegation ID to look for\n" + " -dn <User DN>\n" +
            "\tUser DN to look for\n" + " -p <path location>\n" +
            "\tpath to proxy cache locationUser\n";

        String manPage = null;

        StringBuffer buf = new StringBuffer();
        buf.append(System.getProperty("line.separator"));
        buf.append(System.getProperty("line.separator"));
        buf.append(howToUse);

        manPage = buf.toString();

        if ((args.length > 0) && args[0].equalsIgnoreCase("-help")) {
            System.out.println(manPage);
            System.exit(0);
        }

        // set default options for different methods
        int i;

        for (i = 0; i < args.length; i++) {
            if ((args[i].length() <= 0) || (args[i].charAt(0) != '-')) {
                System.out.println(manPage);
                System.exit(0);
            } else if (args[i].equalsIgnoreCase("-dID")) {
                if ((i + 1) >= args.length) {
                    System.err.println("-dID requires argument");
                }

                try {
                    delegationID = args[++i];
                } catch (NumberFormatException nfe) {
                    System.err.println("illegal argument for -dID");
                    System.exit(0);
                }
            } else if (args[i].equalsIgnoreCase("-dn")) {
                if ((i + 1) >= args.length) {
                    System.err.println("-dn requires argument");
                }

                try {
                    userDN = args[++i];
                } catch (NumberFormatException nfe) {
                    System.err.println("illegal argument for -dn");
                    System.exit(0);
                }
            } else if (args[i].equalsIgnoreCase("-p")) {
                if ((i + 1) >= args.length) {
                    System.err.println("-p requires argument");
                }

                try {
                    cacheLocation = args[++i];
                } catch (NumberFormatException nfe) {
                    System.err.println("illegal argument for -p");
                    System.exit(0);
                }
            }
        }
// TODO: do this with proper GrDPStorageFilesystemFactory etc.
//        System.out.println("Full Path to proxy File is : " +
//            GrDPX509Util.findProxyInCache(cacheLocation, delegationID, userDN));
    }
}
